Index: serefpolicy-contrib-20140730/gnome.if
===================================================================
--- serefpolicy-contrib-20140730.orig/gnome.if
+++ serefpolicy-contrib-20140730/gnome.if
@@ -1,52 +1,78 @@
-## <summary>GNU network object model environment.</summary>
+## <summary>GNU network object model environment (GNOME)</summary>
 
-########################################
+#######################################
 ## <summary>
-##	Role access for gnome.  (Deprecated)
+##  Role access for gnome.  (Deprecated)
 ## </summary>
 ## <param name="role">
-##	<summary>
-##	Role allowed access.
-##	</summary>
+##  <summary>
+##  Role allowed access.
+##  </summary>
 ## </param>
 ## <param name="domain">
-##	<summary>
-##	User domain for the role.
-##	</summary>
+##  <summary>
+##  User domain for the role.
+##  </summary>
 ## </param>
 #
 interface(`gnome_role',`
-	refpolicywarn(`$0($*) has been deprecated')
+    refpolicywarn(`$0($*) has been deprecated')
+    ')
+
+######################################
+## <summary>
+##      The role template for the gnome-keyring-daemon.
+## </summary>
+## <param name="user_prefix">
+##      <summary>
+##      The user prefix.
+##      </summary>
+## </param>
+## <param name="user_role">
+##      <summary>
+##      The user role.
+##      </summary>
+## </param>
+## <param name="user_domain">
+##      <summary>
+##      The user domain associated with the role.
+##      </summary>
+## </param>
+#
+interface(`gnome_role_gkeyringd',`
+    refpolicywarn(`$0($*) has been deprecated')
 ')
 
-#######################################
+######################################
 ## <summary>
-##	The role template for gnome.
+##  The role template for gnome.
 ## </summary>
 ## <param name="role_prefix">
-##	<summary>
-##	The prefix of the user domain (e.g., user
-##	is the prefix for user_t).
-##	</summary>
+##  <summary>
+##  The prefix of the user domain (e.g., user
+##  is the prefix for user_t).
+##  </summary>
 ## </param>
 ## <param name="user_role">
-##	<summary>
-##	The role associated with the user domain.
-##	</summary>
+##  <summary>
+##  The role associated with the user domain.
+##  </summary>
 ## </param>
 ## <param name="user_domain">
-##	<summary>
-##	The type of the user domain.
-##	</summary>
+##  <summary>
+##  The type of the user domain.
+##  </summary>
 ## </param>
 #
 template(`gnome_role_template',`
-	gen_require(`
+    gen_require(`
 		attribute gnomedomain, gkeyringd_domain;
 		attribute_role gconfd_roles;
-		type gkeyringd_exec_t, gnome_keyring_home_t, gnome_keyring_tmp_t;
+        type gnome_home_t;
+		type gkeyringd_exec_t, gkeyringd_gnome_home_t, gkeyringd_tmp_t;
 		type gconfd_t, gconfd_exec_t, gconf_tmp_t;
 		type gconf_home_t;
+        class dbus send_msg;
 	')
 
 	########################################
@@ -76,12 +102,12 @@ template(`gnome_role_template',`
 
 	allow $3 { gconf_home_t gconf_tmp_t }:dir { manage_dir_perms relabel_dir_perms };
 	allow $3 { gconf_home_t gconf_tmp_t }:file { manage_file_perms relabel_file_perms };
-	userdom_user_home_dir_filetrans($3, gconf_home_t, dir, ".gconf")
-	userdom_user_home_dir_filetrans($3, gconf_home_t, dir, ".gconfd")
 
-	allow $3 gconfd_t:process { ptrace signal_perms };
+	allow $3 gconfd_t:process { signal_perms };
+    allow $3 gconfd_t:unix_stream_socket connectto;
 	ps_process_pattern($3, gconfd_t)
 
+
 	########################################
 	#
 	# Gkeyringd policy
@@ -89,37 +115,85 @@ template(`gnome_role_template',`
 
 	domtrans_pattern($3, gkeyringd_exec_t, $1_gkeyringd_t)
 
-	allow $3 { gnome_home_t gnome_keyring_home_t gnome_keyring_tmp_t }:dir { relabel_dir_perms manage_dir_perms };
-	allow $3 { gnome_home_t gnome_keyring_home_t }:file { relabel_file_perms manage_file_perms };
+	allow $3 { gnome_home_t gkeyringd_gnome_home_t gkeyringd_tmp_t }:dir { relabel_dir_perms manage_dir_perms };
+	allow $3 { gnome_home_t gkeyringd_gnome_home_t }:file { relabel_file_perms manage_file_perms };
 
-	userdom_user_home_dir_filetrans($3, gnome_home_t, dir, ".gnome")
-	userdom_user_home_dir_filetrans($3, gnome_home_t, dir, ".gnome2")
-	userdom_user_home_dir_filetrans($3, gnome_home_t, dir, ".gnome2_private")
-	
-	gnome_home_filetrans($3, gnome_keyring_home_t, dir, "keyrings")
+	userdom_home_manager($1_gkeyringd_t)
 
-	allow $3 gnome_keyring_tmp_t:sock_file { relabel_sock_file_perms manage_sock_file_perms };
+	allow $3 gkeyringd_tmp_t:sock_file { relabel_sock_file_perms manage_sock_file_perms };
 
 	ps_process_pattern($3, $1_gkeyringd_t)
-	allow $3 $1_gkeyringd_t:process { ptrace signal_perms };
+	allow $3 $1_gkeyringd_t:process signal_perms;
+	dontaudit $3 gkeyringd_exec_t:file entrypoint;
+
+	allow $1_gkeyringd_t $3:process sigkill;
+	allow $3 $1_gkeyringd_t:fd use;
+	allow $3 $1_gkeyringd_t:fifo_file rw_fifo_file_perms;
+
+	dontaudit $1_gkeyringd_t $3:unix_stream_socket { getattr read write };
+	stream_connect_pattern($3, gkeyringd_tmp_t, gkeyringd_tmp_t, $1_gkeyringd_t)
+
+	kernel_read_system_state($1_gkeyringd_t)
 
 	corecmd_bin_domtrans($1_gkeyringd_t, $3)
 	corecmd_shell_domtrans($1_gkeyringd_t, $3)
 
-	gnome_stream_connect_gkeyringd($1, $3)
+	gnome_stream_connect_gkeyringd($3)
+
+	ps_process_pattern($1_gkeyringd_t, $3)
+
+	auth_use_nsswitch($1_gkeyringd_t)
+
+	logging_send_syslog_msg($1_gkeyringd_t)
+
+	allow $1_gkeyringd_t $3:dbus send_msg;
+	allow $3 $1_gkeyringd_t:dbus send_msg;
 
 	optional_policy(`
-		dbus_spec_session_domain($1, $1_gkeyringd_t, gkeyringd_exec_t)
+        dbus_session_domain($1, gkeyringd_exec_t, $1_gkeyringd_t)
+		gnome_manage_generic_home_dirs($1_gkeyringd_t)
+		gnome_read_generic_data_home_files($1_gkeyringd_t)
+		gnome_read_generic_data_home_dirs($1_gkeyringd_t)
 
 		optional_policy(`
-			gnome_dbus_chat_gkeyringd($1, $3)
+			telepathy_mission_control_read_state($1_gkeyringd_t)
+            telepathy_gabble_stream_connect_to($1_gkeyringd_t,gkeyringd_tmp_t,gkeyringd_tmp_t)
 		')
 	')
 ')
 
+#######################################
+## <summary>
+##  Allow domain to run gkeyring in the $1_gkeyringd_t domain.
+## </summary>
+## <param name="user_prefix">
+##      <summary>
+##      The user prefix.
+##      </summary>
+## </param>
+## <param name="user_role">
+##      <summary>
+##      The user role.
+##      </summary>
+## </param>
+## <param name="user_domain">
+##      <summary>
+##	Domain allowed access.
+##      </summary>
+## </param>
+#
+interface(`gnome_run_gkeyringd',`
+    gen_require(`
+		type $1_gkeyringd_t;
+		type gkeyringd_exec_t;
+	')
+	role $2 types $1_gkeyringd_t;
+	domtrans_pattern($3, gkeyringd_exec_t, $1_gkeyringd_t)
+')
+
 ########################################
 ## <summary>
-##	Execute gconf in the caller domain.
+##	gconf connection template.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -127,18 +201,18 @@ template(`gnome_role_template',`
 ##	</summary>
 ## </param>
 #
-interface(`gnome_exec_gconf',`
+interface(`gnome_stream_connect_gconf',`
 	gen_require(`
-		type gconfd_exec_t;
+		type gconfd_t, gconf_tmp_t;
 	')
 
-	corecmd_search_bin($1)
-	can_exec($1, gconfd_exec_t)
+	read_files_pattern($1, gconf_tmp_t, gconf_tmp_t)
+	allow $1 gconfd_t:unix_stream_socket connectto;
 ')
 
 ########################################
 ## <summary>
-##	Read gconf configuration content.
+##	Connect to gkeyringd with a unix stream socket. 
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -146,119 +220,114 @@ interface(`gnome_exec_gconf',`
 ##	</summary>
 ## </param>
 #
-interface(`gnome_read_gconf_config',`
+interface(`gnome_stream_connect_gkeyringd',`
 	gen_require(`
-		type gconf_etc_t;
+			attribute gkeyringd_domain;
+			type gkeyringd_tmp_t;
+			type gconf_tmp_t;
+			type cache_home_t;
 	')
 
-	files_search_etc($1)
-	allow $1 gconf_etc_t:dir list_dir_perms;
-	allow $1 gconf_etc_t:file read_file_perms;
-	allow $1 gconf_etc_t:lnk_file read_lnk_file_perms;
+	allow $1 gconf_tmp_t:dir search_dir_perms;
+	userdom_search_user_tmp_dirs($1)
+	stream_connect_pattern($1, gkeyringd_tmp_t, gkeyringd_tmp_t, gkeyringd_domain)
+	stream_connect_pattern($1, cache_home_t, cache_home_t, gkeyringd_domain)
 ')
 
 ########################################
 ## <summary>
-##	Do not audit attempts to read
-##	inherited gconf configuration files.
+##	Run gconfd in gconfd domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain to not audit.
+##	Domain allowed access.
 ##	</summary>
 ## </param>
 #
-interface(`gnome_dontaudit_read_inherited_gconf_config_files',`
+interface(`gnome_domtrans_gconfd',`
 	gen_require(`
-		type gconf_etc_t;
+		type gconfd_t, gconfd_exec_t;
 	')
 
-	dontaudit $1 gconf_etc_t:file read;
+	domtrans_pattern($1, gconfd_exec_t, gconfd_t)
 ')
 
-#######################################
+########################################
 ## <summary>
-##	Create, read, write, and delete
-##	gconf configuration content.
+##	Dontaudit read gnome homedir content (.config)
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed access.
+##	Domain to not audit.
 ##	</summary>
 ## </param>
 #
-interface(`gnome_manage_gconf_config',`
+interface(`gnome_dontaudit_read_config',`
 	gen_require(`
-		type gconf_etc_t;
+		attribute gnome_home_type;
 	')
 
-	files_search_etc($1)
-	allow $1 gconf_etc_t:dir manage_dir_perms;
-	allow $1 gconf_etc_t:file manage_file_perms;
-	allow $1 gconf_etc_t:lnk_file manage_lnk_file_perms;
+	dontaudit $1 gnome_home_type:dir read_inherited_file_perms;
 ')
 
 ########################################
 ## <summary>
-##	Connect to gconf using a unix
-##	domain stream socket.
+##	Dontaudit search gnome homedir content (.config)
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed access.
+##	Domain to not audit.
 ##	</summary>
 ## </param>
 #
-interface(`gnome_stream_connect_gconf',`
+interface(`gnome_dontaudit_search_config',`
 	gen_require(`
-		type gconfd_t, gconf_tmp_t;
+		attribute gnome_home_type;
 	')
 
-	files_search_tmp($1)
-	stream_connect_pattern($1, gconf_tmp_t, gconf_tmp_t, gconfd_t)
+	dontaudit $1 gnome_home_type:dir search_dir_perms;
 ')
 
 ########################################
 ## <summary>
-##	Run gconfd in gconfd domain.
+##	Dontaudit write gnome homedir content (.config)
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed to transition.
+##	Domain to not audit.
 ##	</summary>
 ## </param>
 #
-interface(`gnome_domtrans_gconfd',`
+interface(`gnome_dontaudit_append_config_files',`
 	gen_require(`
-		type gconfd_t, gconfd_exec_t;
+		attribute gnome_home_type;
 	')
 
-	corecmd_search_bin($1)
-	domtrans_pattern($1, gconfd_exec_t, gconfd_t)
+	dontaudit $1 gnome_home_type:file append;
 ')
 
+
 ########################################
 ## <summary>
-##	Create generic gnome home directories.
+##	Dontaudit write gnome homedir content (.config)
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed access.
+##	Domain to not audit.
 ##	</summary>
 ## </param>
 #
-interface(`gnome_create_generic_home_dirs',`
+interface(`gnome_dontaudit_write_config_files',`
 	gen_require(`
-		type gnome_home_t;
+		attribute gnome_home_type;
 	')
 
-	allow $1 gnome_home_t:dir create_dir_perms;
+	dontaudit $1 gnome_home_type:file write;
 ')
 
 ########################################
 ## <summary>
-##	Set attributes of generic gnome
-##	user home directories.  (Deprecated)
+##	manage gnome homedir content (.config)
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -266,15 +335,21 @@ interface(`gnome_create_generic_home_dir
 ##	</summary>
 ## </param>
 #
-interface(`gnome_setattr_config_dirs',`
-	refpolicywarn(`$0($*) has been deprecated, use gnome_setattr_generic_home_dirs() instead.')
-	gnome_setattr_generic_home_dirs($1)
+interface(`gnome_manage_config',`
+	gen_require(`
+		attribute gnome_home_type;
+	')
+
+	allow $1 gnome_home_type:dir manage_dir_perms;
+	allow $1 gnome_home_type:file manage_file_perms;
+	allow $1 gnome_home_type:lnk_file manage_lnk_file_perms;
+	allow $1 gnome_home_type:sock_file manage_sock_file_perms;
+	userdom_search_user_home_dirs($1)
 ')
 
 ########################################
 ## <summary>
-##	Set attributes of generic gnome
-##	user home directories.
+##	Send general signals to all gconf domains.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -282,57 +357,89 @@ interface(`gnome_setattr_config_dirs',`
 ##	</summary>
 ## </param>
 #
-interface(`gnome_setattr_generic_home_dirs',`
+interface(`gnome_signal_all',`
 	gen_require(`
-		type gnome_home_t;
+		attribute gnomedomain;
 	')
 
-	userdom_search_user_home_dirs($1)
-	setattr_dirs_pattern($1, gnome_home_t, gnome_home_t)
+	allow $1 gnomedomain:process signal;
 ')
 
 ########################################
 ## <summary>
-##	Read generic gnome user home content.  (Deprecated)
+##	Create objects in a Gnome cache home directory
+##	with an automatic type transition to
+##	a specified private type.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
+## <param name="private_type">
+##	<summary>
+##	The type of the object to create.
+##	</summary>
+## </param>
+## <param name="object_class">
+##	<summary>
+##	The class of the object to be created.
+##	</summary>
+## </param>
+## <param name="name" optional="true">
+##	<summary>
+##	The name of the object being created.
+##	</summary>
+## </param>
 #
-interface(`gnome_read_config',`
-	refpolicywarn(`$0($*) has been deprecated, use gnome_read_generic_home_content() instead.')
-	gnome_read_generic_home_content($1)
+interface(`gnome_cache_filetrans',`
+	gen_require(`
+		type cache_home_t;
+	')
+
+	filetrans_pattern($1, cache_home_t, $2, $3, $4)
+	userdom_search_user_home_dirs($1)
 ')
 
 ########################################
 ## <summary>
-##	Read generic gnome home content.
+##	Create objects in a Gnome cache home directory
+##	with an automatic type transition to
+##	a specified private type.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
+## <param name="private_type">
+##	<summary>
+##	The type of the object to create.
+##	</summary>
+## </param>
+## <param name="object_class">
+##	<summary>
+##	The class of the object to be created.
+##	</summary>
+## </param>
+## <param name="name" optional="true">
+##	<summary>
+##	The name of the object being created.
+##	</summary>
+## </param>
 #
-interface(`gnome_read_generic_home_content',`
+interface(`gnome_config_filetrans',`
 	gen_require(`
-		type gnome_home_t;
+		type config_home_t;
 	')
 
+	filetrans_pattern($1, config_home_t, $2, $3, $4)
 	userdom_search_user_home_dirs($1)
-	allow $1 gnome_home_t:dir list_dir_perms;
-	allow $1 gnome_home_t:file read_file_perms;
-	allow $1 gnome_home_t:fifo_file read_fifo_file_perms;
-	allow $1 gnome_home_t:lnk_file read_lnk_file_perms;
-	allow $1 gnome_home_t:sock_file read_sock_file_perms;
 ')
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	generic gnome user home content.  (Deprecated)
+##	Read generic cache home files (.cache)
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -340,15 +447,18 @@ interface(`gnome_read_generic_home_conte
 ##	</summary>
 ## </param>
 #
-interface(`gnome_manage_config',`
-	refpolicywarn(`$0($*) has been deprecated, use gnome_manage_generic_home_content() instead.')
-	gnome_manage_generic_home_content($1)
+interface(`gnome_read_generic_cache_files',`
+	gen_require(`
+		type cache_home_t;
+	')
+
+	read_files_pattern($1, cache_home_t, cache_home_t)
+	userdom_search_user_home_dirs($1)
 ')
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	generic gnome home content.
+##	Create generic cache home dir (.cache)
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -356,22 +466,18 @@ interface(`gnome_manage_config',`
 ##	</summary>
 ## </param>
 #
-interface(`gnome_manage_generic_home_content',`
+interface(`gnome_create_generic_cache_dir',`
 	gen_require(`
-		type gnome_home_t;
+		type cache_home_t;
 	')
 
-	userdom_search_user_home_dirs($1)
-	allow $1 gnome_home_t:dir manage_dir_perms;
-	allow $1 gnome_home_t:file manage_file_perms;
-	allow $1 gnome_home_t:fifo_file manage_fifo_file_perms;
-	allow $1 gnome_home_t:lnk_file manage_lnk_file_perms;
-	allow $1 gnome_home_t:sock_file manage_sock_file_perms;
+	allow $1 cache_home_t:dir create_dir_perms;
+	userdom_user_home_dir_filetrans($1, cache_home_t, dir, ".cache")
 ')
 
 ########################################
 ## <summary>
-##	Search generic gnome home directories.
+##	Set attributes of cache home dir (.cache)
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -379,53 +485,37 @@ interface(`gnome_manage_generic_home_con
 ##	</summary>
 ## </param>
 #
-interface(`gnome_search_generic_home',`
+interface(`gnome_setattr_cache_home_dir',`
 	gen_require(`
-		type gnome_home_t;
+		type cache_home_t;
 	')
 
+	setattr_dirs_pattern($1, cache_home_t, cache_home_t)
 	userdom_search_user_home_dirs($1)
-	allow $1 gnome_home_t:dir search_dir_perms;
 ')
 
 ########################################
 ## <summary>
-##	Create objects in gnome user home
-##	directories with a private type.
+##	Manage cache home dir (.cache)
 ## </summary>
 ## <param name="domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
-## <param name="private_type">
-##	<summary>
-##	Private file type.
-##	</summary>
-## </param>
-## <param name="object_class">
-##	<summary>
-##	Class of the object being created.
-##	</summary>
-## </param>
-## <param name="name" optional="true">
-##	<summary>
-##	The name of the object being created.
-##	</summary>
-## </param>
 #
-interface(`gnome_home_filetrans',`
+interface(`gnome_manage_cache_home_dir',`
 	gen_require(`
-		type gnome_home_t;
+		type cache_home_t;
 	')
 
+	manage_dirs_pattern($1, cache_home_t, cache_home_t)
 	userdom_search_user_home_dirs($1)
-	filetrans_pattern($1, gnome_home_t, $2, $3, $4)
 ')
 
 ########################################
 ## <summary>
-##	Create generic gconf home directories.
+##	append to generic cache home files (.cache)
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -433,17 +523,18 @@ interface(`gnome_home_filetrans',`
 ##	</summary>
 ## </param>
 #
-interface(`gnome_create_generic_gconf_home_dirs',`
+interface(`gnome_append_generic_cache_files',`
 	gen_require(`
-		type gconf_home_t;
+		type cache_home_t;
 	')
 
-	allow $1 gconf_home_t:dir create_dir_perms;
+	append_files_pattern($1, cache_home_t, cache_home_t)
+	userdom_search_user_home_dirs($1)
 ')
 
 ########################################
 ## <summary>
-##	Read generic gconf home content.
+##	write to generic cache home files (.cache)
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -451,23 +542,18 @@ interface(`gnome_create_generic_gconf_ho
 ##	</summary>
 ## </param>
 #
-interface(`gnome_read_generic_gconf_home_content',`
+interface(`gnome_write_generic_cache_files',`
 	gen_require(`
-		type gconf_home_t;
+		type cache_home_t;
 	')
 
+	write_files_pattern($1, cache_home_t, cache_home_t)
 	userdom_search_user_home_dirs($1)
-	allow $1 gconf_home_t:dir list_dir_perms;
-	allow $1 gconf_home_t:file read_file_perms;
-	allow $1 gconf_home_t:fifo_file read_fifo_file_perms;
-	allow $1 gconf_home_t:lnk_file read_lnk_file_perms;
-	allow $1 gconf_home_t:sock_file read_sock_file_perms;
 ')
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	generic gconf home content.
+##	write to generic cache home files (.cache)
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -475,22 +561,18 @@ interface(`gnome_read_generic_gconf_home
 ##	</summary>
 ## </param>
 #
-interface(`gnome_manage_generic_gconf_home_content',`
+interface(`gnome_manage_generic_cache_files',`
 	gen_require(`
-		type gconf_home_t;
+		type cache_home_t;
 	')
 
+	manage_files_pattern($1, cache_home_t, cache_home_t)
 	userdom_search_user_home_dirs($1)
-	allow $1 gconf_home_t:dir manage_dir_perms;
-	allow $1 gconf_home_t:file manage_file_perms;
-	allow $1 gconf_home_t:fifo_file manage_fifo_file_perms;
-	allow $1 gconf_home_t:lnk_file manage_lnk_file_perms;
-	allow $1 gconf_home_t:sock_file manage_sock_file_perms;
 ')
 
 ########################################
 ## <summary>
-##	Search generic gconf home directories.
+##	Manage a sock_file in the generic cache home files (.cache)
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -498,79 +580,59 @@ interface(`gnome_manage_generic_gconf_ho
 ##	</summary>
 ## </param>
 #
-interface(`gnome_search_generic_gconf_home',`
+interface(`gnome_manage_generic_cache_sockets',`
 	gen_require(`
-		type gconf_home_t;
+		type cache_home_t;
 	')
 
 	userdom_search_user_home_dirs($1)
-	allow $1 gconf_home_t:dir search_dir_perms;
+	manage_sock_files_pattern($1, cache_home_t, cache_home_t)
 ')
 
 ########################################
 ## <summary>
-##	Create objects in user home
-##	directories with the generic gconf
-##	home type.
+##	Dontaudit read/write to generic cache home files (.cache)
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed access.
-##	</summary>
-## </param>
-## <param name="object_class">
-##	<summary>
-##	Class of the object being created.
-##	</summary>
-## </param>
-## <param name="name" optional="true">
-##	<summary>
-##	The name of the object being created.
+##	Domain to not audit.
 ##	</summary>
 ## </param>
 #
-interface(`gnome_home_filetrans_gconf_home',`
+interface(`gnome_dontaudit_rw_generic_cache_files',`
 	gen_require(`
-		type gconf_home_t;
+		type cache_home_t;
 	')
 
-	userdom_user_home_dir_filetrans($1, gconf_home_t, $2, $3)
+	dontaudit $1 cache_home_t:file rw_inherited_file_perms;
 ')
 
 ########################################
 ## <summary>
-##	Create objects in user home
-##	directories with the generic gnome
-##	home type.
+##	read gnome homedir content (.config)
 ## </summary>
 ## <param name="domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
-## <param name="object_class">
-##	<summary>
-##	Class of the object being created.
-##	</summary>
-## </param>
-## <param name="name" optional="true">
-##	<summary>
-##	The name of the object being created.
-##	</summary>
-## </param>
 #
-interface(`gnome_home_filetrans_gnome_home',`
+interface(`gnome_read_config',`
 	gen_require(`
-		type gnome_home_t;
+		attribute gnome_home_type;
 	')
 
-	userdom_user_home_dir_filetrans($1, gnome_home_t, $2, $3)
+	list_dirs_pattern($1, gnome_home_type, gnome_home_type)
+	read_files_pattern($1, gnome_home_type, gnome_home_type)
+	read_lnk_files_pattern($1, gnome_home_type, gnome_home_type)
+	gnome_read_usr_config($1)
 ')
 
 ########################################
 ## <summary>
-##	Create objects in gnome gconf home
-##	directories with a private type.
+##	Create objects in a Gnome gconf home directory
+##	with an automatic type transition to
+##	a specified private type.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -579,12 +641,12 @@ interface(`gnome_home_filetrans_gnome_ho
 ## </param>
 ## <param name="private_type">
 ##	<summary>
-##	Private file type.
+##	The type of the object to create.
 ##	</summary>
 ## </param>
 ## <param name="object_class">
 ##	<summary>
-##	Class of the object being created.
+##	The class of the object to be created.
 ##	</summary>
 ## </param>
 ## <param name="name" optional="true">
@@ -593,18 +655,18 @@ interface(`gnome_home_filetrans_gnome_ho
 ##	</summary>
 ## </param>
 #
-interface(`gnome_gconf_home_filetrans',`
+interface(`gnome_data_filetrans',`
 	gen_require(`
-		type gconf_home_t;
+		type data_home_t;
 	')
 
-	userdom_search_user_home_dirs($1)
-	filetrans_pattern($1, gconf_home_t, $2, $3, $4)
+	filetrans_pattern($1, data_home_t, $2, $3, $4)
+	gnome_search_gconf($1)
 ')
 
-########################################
+#######################################
 ## <summary>
-##	Read generic gnome keyring home files.
+##	Read generic data home files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -612,46 +674,58 @@ interface(`gnome_gconf_home_filetrans',`
 ##	</summary>
 ## </param>
 #
-interface(`gnome_read_keyring_home_files',`
+interface(`gnome_read_generic_data_home_files',`
 	gen_require(`
-		type gnome_home_t, gnome_keyring_home_t;
+		type data_home_t, gconf_home_t;
 	')
 
-	userdom_search_user_home_dirs($1)
-	read_files_pattern($1, { gnome_home_t gnome_keyring_home_t }, gnome_keyring_home_t)
+	read_files_pattern($1, { gconf_home_t data_home_t }, data_home_t)
+	read_lnk_files_pattern($1, { gconf_home_t data_home_t }, data_home_t)
 ')
 
-########################################
+######################################
 ## <summary>
-##	Send and receive messages from
-##	gnome keyring daemon over dbus.
+##  Read generic data home dirs.
 ## </summary>
-## <param name="role_prefix">
-##	<summary>
-##	The prefix of the user domain (e.g., user
-##	is the prefix for user_t).
-##	</summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access.
+##  </summary>
 ## </param>
+#
+interface(`gnome_read_generic_data_home_dirs',`
+    gen_require(`
+        type data_home_t, gconf_home_t;
+    ')
+
+    list_dirs_pattern($1, { gconf_home_t data_home_t }, data_home_t)
+')
+
+#######################################
+## <summary>
+##	Manage gconf data home files
+## </summary>
 ## <param name="domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
 #
-interface(`gnome_dbus_chat_gkeyringd',`
+interface(`gnome_manage_data',`
 	gen_require(`
-		type $1_gkeyringd_t;
-		class dbus send_msg;
+		type data_home_t;
+		type gconf_home_t;
 	')
 
-	allow $2 $1_gkeyringd_t:dbus send_msg;
-	allow $1_gkeyringd_t $2:dbus send_msg;
+	allow $1 gconf_home_t:dir search_dir_perms;
+	manage_dirs_pattern($1, data_home_t, data_home_t)
+	manage_files_pattern($1, data_home_t, data_home_t)
+	manage_lnk_files_pattern($1, data_home_t, data_home_t)
 ')
 
 ########################################
 ## <summary>
-##	Send and receive messages from all
-##	gnome keyring daemon over dbus.
+##	Read icc data home content.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -659,66 +733,86 @@ interface(`gnome_dbus_chat_gkeyringd',`
 ##	</summary>
 ## </param>
 #
-interface(`gnome_dbus_chat_all_gkeyringd',`
+interface(`gnome_read_home_icc_data_content',`
 	gen_require(`
-		attribute gkeyringd_domain;
-		class dbus send_msg;
+		type icc_data_home_t, gconf_home_t, data_home_t;
 	')
 
-	allow $1 gkeyringd_domain:dbus send_msg;
-	allow gkeyringd_domain $1:dbus send_msg;
+	userdom_search_user_home_dirs($1)
+	allow $1 { gconf_home_t data_home_t }:dir search_dir_perms;
+	list_dirs_pattern($1, icc_data_home_t, icc_data_home_t)
+	read_files_pattern($1, icc_data_home_t, icc_data_home_t)
+	read_lnk_files_pattern($1, icc_data_home_t, icc_data_home_t)
 ')
 
 ########################################
 ## <summary>
-##	Run all gkeyringd in gkeyringd domain.
+##	Read inherited icc data home files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed to transition.
+##	Domain allowed access.
 ##	</summary>
 ## </param>
 #
-interface(`gnome_spec_domtrans_all_gkeyringd',`
+interface(`gnome_read_inherited_home_icc_data_files',`
 	gen_require(`
-		attribute gkeyringd_domain;
-		type gkeyringd_exec_t;
+		type icc_data_home_t;
 	')
 
-	corecmd_search_bin($1)
-	spec_domtrans_pattern($1, gkeyringd_exec_t, gkeyringd_domain)
+	allow $1 icc_data_home_t:file read_inherited_file_perms;
 ')
 
 ########################################
 ## <summary>
-##	Connect to gnome keyring daemon
-##	with a unix stream socket.
+##	Create gconf_home_t objects in the /root directory
 ## </summary>
-## <param name="role_prefix">
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+## <param name="object_class">
 ##	<summary>
-##	The prefix of the user domain (e.g., user
-##	is the prefix for user_t).
+##	The class of the object to be created.
 ##	</summary>
 ## </param>
+## <param name="name" optional="true">
+##	<summary>
+##	The name of the object being created.
+##	</summary>
+## </param>
+#
+interface(`gnome_admin_home_gconf_filetrans',`
+	gen_require(`
+		type gconf_home_t;
+	')
+
+	userdom_admin_home_dir_filetrans($1, gconf_home_t, $2, $3)
+')
+
+########################################
+## <summary>
+##	Do not audit attempts to read
+##	inherited gconf config files.
+## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed access.
+##	Domain to not audit.
 ##	</summary>
 ## </param>
 #
-interface(`gnome_stream_connect_gkeyringd',`
+interface(`gnome_dontaudit_read_inherited_gconf_config_files',`
 	gen_require(`
-		type $1_gkeyringd_t, gnome_keyring_tmp_t;
+		type gconf_etc_t;
 	')
 
-	files_search_tmp($2)
-	stream_connect_pattern($2, gnome_keyring_tmp_t, gnome_keyring_tmp_t, $1_gkeyringd_t)
+	dontaudit $1 gconf_etc_t:file read_inherited_file_perms;
 ')
 
 ########################################
 ## <summary>
-##	Connect to all gnome keyring daemon
-##	with a unix stream socket.
+##	read gconf config files
 ## </summary>
 ## <param name="domain">
 ##	<summary>
